# IRC desklet for gDesklets (http://gdesklets.gnomedesktop.org)
# Copyright (C) 2003  Seth Remington

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import gtk

class message_window:
    def __init__(self, x, y, send_func, tab_func):
        self.isVisible = 0
        self.send_func = send_func
        self.tab_func = tab_func
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_decorated(0)
        self.window.connect("delete_event", self.catch_delete, None)
        self.entry = gtk.Entry()
        self.entry.set_has_frame(0)
        self.entry.set_width_chars(30)
        self.entry.connect("activate", self.activate, None)
        self.entry.connect("key_press_event", self.on_key_press_event, None)
        self.window.add(self.entry)
        self.window.move(x, y)

    def show_or_hide(self, x = None, y = None):
        if self.isVisible:
            self.hide()
        else:
            self.show(x, y)

    def show(self, x = None, y = None):
        if x and y:
            self.window.move(x, y)
        self.window.show_all()
        self.isVisible = 1

    def hide(self):
        self.window.hide_all()
        self.isVisible = 0

    def catch_delete(self, widget, *args):
        self.window.hide_all()
        return gtk.TRUE

    def destroy(self):
        self.window.destroy()

    def activate(self, widget, data):
        self.send_func(widget.get_text())
        widget.set_text("")

    def on_key_press_event(self, widget, key, data):
        if key.keyval == gtk.keysyms.Tab:
            text = widget.get_text()
            words = text.split(" ")
            self.tab_complete(widget, words[-1])
            return gtk.TRUE

    def tab_complete(self, widget, start):
        self.tab_func(widget, start)
